"use strict";
var universal = require('angular2-universal-preview');
var through = require('through2');
var gutil = require('gutil');
var PluginError = gutil.PluginError;
function prerender(options) {
    return through.obj(function (file, enc, cb) {
        if (file.isStream()) {
            return cb(new PluginError('angular2-gulp-prerender', 'Streaming is not supported'));
        }
        var template = file.contents.toString();
        // bootstrap and render component to string
        var bootloader = options.bootloader;
        if (!options.bootloader) {
            options.bootloader = {
                document: universal.parseDocument(template),
                providers: options.providers,
                componentProviders: options.componentProviders,
                platformProviders: options.platformProviders,
                directives: options.directives,
                preboot: options.preboot
            };
        }
        bootloader = universal.Bootloader.create(options.bootloader);
        return bootloader.serializeApplication()
            .then(function (html) {
            file.contents = new Buffer(html);
            cb(null, file);
        });
    });
}
exports.prerender = prerender;
function GulpAngular2Render(options) {
    console.warn('DEPRECATION WARNING: `GulpAngular2Render` is no longer supported and will be removed in next release. use `Prerender`');
    return prerender(options);
}
exports.GulpAngular2Render = GulpAngular2Render;
//# sourceMappingURL=prerender.js.map